package it.micegroup.gestioneferie.pianificazioneferie.entity;

import java.io.Serializable;

import javax.validation.constraints.NotNull;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.FetchType;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.annotation.JsonBackReference;
import javax.persistence.ManyToOne;
import javax.validation.constraints.NotNull;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DrichAdesionePfKey;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_SOLLECITI_PF")
public class DsollecitiPf extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = 1774707848L;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DsollecitiPf.class);

	// ATTRIBUTES
	@NotNull

	@Column(name = "SEQU_ID_SOLLECITO_PF", columnDefinition = "NUMBER(15)")
	private Long sequIdSollecitoPf;
	@NotNull

	@Column(name = "CODI_SOLLECITO", columnDefinition = "VARCHAR(50)")
	private String codiSollecito;
	@NotNull

	@Column(name = "DATA_SOLLECITO", columnDefinition = "DATE")
	private Date dataSollecito;
	@Column(name = "TEXT_MOTIVAZIONE", columnDefinition = "LONGTEXT")
	private String textMotivazione;
	@NotNull

	@Column(name = "FK_AMMINISTRATO", columnDefinition = "NUMBER(15)")
	private Long fkAmministrato;
	@NotNull

	@Column(name = "FK_RICHIESTA_ADESIONE", columnDefinition = "NUMBER(15)")
	private Long fkRichiestaAdesione;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "DATA_INIZIO_RECORD", columnDefinition = "DATE")
	private Date dataInizioRecord;
	@NotNull

	@Column(name = "DATA_FINE_RECORD", columnDefinition = "DATE")
	private Date dataFineRecord;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DsollecitiPf(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DsollecitiPf(DsollecitiPfKey dsollecitiPfKey, Long sequIdSollecitoPf, String codiSollecito,
			Date dataSollecito, String textMotivazione, Long fkAmministrato, Long fkRichiestaAdesione,
			String flagEliminato, String utenteUltimaModifica, Date dataUltimaModifica, Date dataInizioRecord,
			Date dataFineRecord) {
		super();

		this.dsollecitiPfKey = dsollecitiPfKey;

		this.sequIdSollecitoPf = sequIdSollecitoPf;
		this.codiSollecito = codiSollecito;
		this.dataSollecito = dataSollecito;
		this.textMotivazione = textMotivazione;
		this.fkAmministrato = fkAmministrato;
		this.fkRichiestaAdesione = fkRichiestaAdesione;
		this.flagEliminato = flagEliminato;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataUltimaModifica = dataUltimaModifica;
		this.dataInizioRecord = dataInizioRecord;
		this.dataFineRecord = dataFineRecord;
	}

	// CHILDREN

	// PARENTS
	@NotNull
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonBackReference("theDrichAdesionePf")
	@JsonIgnoreProperties(value = { "hibernateLazyInitializer", "handler" }, allowSetters = true)
	private DrichAdesionePf theDrichAdesionePf;

	// GETTER/SETTER
	/**
	 * @return the sequIdSollecitoPf
	 */
	public Long getSequIdSollecitoPf() {
		return this.sequIdSollecitoPf;
	}

	/**
	 * @param sequIdSollecitoPf to set
	 */
	public void setSequIdSollecitoPf(Long sequIdSollecitoPf) {
		this.sequIdSollecitoPf = sequIdSollecitoPf;
	}

	/**
	 * @return the codiSollecito
	 */
	public String getCodiSollecito() {
		return this.codiSollecito;
	}

	/**
	 * @param codiSollecito to set
	 */
	public void setCodiSollecito(String codiSollecito) {
		this.codiSollecito = codiSollecito;
	}

	/**
	 * @return the dataSollecito
	 */
	public Date getDataSollecito() {
		return this.dataSollecito;
	}

	/**
	 * @param dataSollecito to set
	 */
	public void setDataSollecito(Date dataSollecito) {
		this.dataSollecito = dataSollecito;
	}

	/**
	 * @return the textMotivazione
	 */
	public String getTextMotivazione() {
		return this.textMotivazione;
	}

	/**
	 * @param textMotivazione to set
	 */
	public void setTextMotivazione(String textMotivazione) {
		this.textMotivazione = textMotivazione;
	}

	/**
	 * @return the fkAmministrato
	 */
	public Long getFkAmministrato() {
		return this.fkAmministrato;
	}

	/**
	 * @param fkAmministrato to set
	 */
	public void setFkAmministrato(Long fkAmministrato) {
		this.fkAmministrato = fkAmministrato;
	}

	/**
	 * @return the fkRichiestaAdesione
	 */
	public Long getFkRichiestaAdesione() {
		return this.fkRichiestaAdesione;
	}

	/**
	 * @param fkRichiestaAdesione to set
	 */
	public void setFkRichiestaAdesione(Long fkRichiestaAdesione) {
		this.fkRichiestaAdesione = fkRichiestaAdesione;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the dataInizioRecord
	 */
	public Date getDataInizioRecord() {
		return this.dataInizioRecord;
	}

	/**
	 * @param dataInizioRecord to set
	 */
	public void setDataInizioRecord(Date dataInizioRecord) {
		this.dataInizioRecord = dataInizioRecord;
	}

	/**
	 * @return the dataFineRecord
	 */
	public Date getDataFineRecord() {
		return this.dataFineRecord;
	}

	/**
	 * @param dataFineRecord to set
	 */
	public void setDataFineRecord(Date dataFineRecord) {
		this.dataFineRecord = dataFineRecord;
	}

	// CHILD GETTER/SETTER

	/// ADD CHILD

	// PARENT GETTER/SETTER
	/**
	 * @return the DrichAdesionePf
	 */
	@JsonProperty(access = Access.WRITE_ONLY)
	public DrichAdesionePf getTheDrichAdesionePf() {
		return theDrichAdesionePf;
	}

	/**
	 * @param aDrichAdesionePfList to set
	 */
	public void setTheDrichAdesionePf(DrichAdesionePf aDrichAdesionePf) {
		theDrichAdesionePf = aDrichAdesionePf;
	}

	// PARENT ID GETTER/SETTER
	/**
	 * Return the drichAdesionePfKey from theDrichAdesionePf.
	 * 
	 * @return drichAdesionePfKey from theDrichAdesionePf.
	 */
	@JsonProperty
	public DrichAdesionePfKey getDrichAdesionePfKey() {
		// If the parent entity object is null, then return null
		if (getTheDrichAdesionePf() == null) {
			return null;
		}
		// Return requested attribute
		return theDrichAdesionePf.getDrichAdesionePfKey();
	}

	// PARENT OBJECT TITLE
	/**
	 * Return the object title of theDrichAdesionePf.
	 * 
	 * @return the object title of theDrichAdesionePf.
	 */
	@JsonProperty
	public String getTheDrichAdesionePfObjectTitle() {
		return getTheDrichAdesionePf() != null ? getTheDrichAdesionePf().getObjectTitle() : null;
	}

	// PARENT OBJECT KEY
	/**
	 * Return the object key of theDrichAdesionePf.
	 * 
	 * @return the object key of theDrichAdesionePf.
	 */
	@JsonProperty
	public String getTheDrichAdesionePfObjectKey() {
		return getTheDrichAdesionePf() != null ? getTheDrichAdesionePf().getObjectKey() : null;
	}

	/**
	 * Set object key of theDrichAdesionePf.
	 * 
	 */
	@JsonProperty
	public void setTheDrichAdesionePfObjectKey(String objectKey) {
		if (EntityUtils.isValueChanged(getTheDrichAdesionePfObjectKey(), objectKey, false)) {
			DrichAdesionePf drichAdesionePf = new DrichAdesionePf();
			drichAdesionePf.setObjectKey(objectKey);
			setTheDrichAdesionePf(drichAdesionePf);
		}
	}

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getDsollecitiPfKey());
	}

	public String getObjectKeyById(DsollecitiPfKey identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		dsollecitiPfKey = new DsollecitiPfKey();
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(getCodiSollecito());
		return output.toString();
	}

	// COMPOSITE PRIMARY KEY
	@EmbeddedId
	private DsollecitiPfKey dsollecitiPfKey;

	// GETTER/SETTER CK
	/**
	 * @return the dsollecitiPfKey
	 */
	public DsollecitiPfKey getDsollecitiPfKey() {
		return this.dsollecitiPfKey;
	}

	/**
	 * @param dsollecitiPfKey to set
	 */
	public void setDsollecitiPfKey(DsollecitiPfKey dsollecitiPfKey) {
		this.dsollecitiPfKey = dsollecitiPfKey;
	}

	// COMPOSITE KEY CLASS

	// PREPERSIST
	public void syncCK() {
		if (dsollecitiPfKey == null) {
			dsollecitiPfKey = new DsollecitiPfKey();
		}
	}

	@PrePersist
	public void prePersist() {
		syncCK();
	}

	@PreUpdate
	public void PreUpdate() {
		syncCK();
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DsollecitiPf that = (DsollecitiPf) o;
		return dsollecitiPfKey != null && Objects.equals(dsollecitiPfKey, that.dsollecitiPfKey);
	}

	@Override
	public int hashCode() {
		return Objects.hash(dsollecitiPfKey);
	}
}
